--[[=============================================================================
    File is: camera_communicator.lua

    Copyright 2018 Control4 Corporation. All Rights Reserved.
===============================================================================]]

if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.camera_communicator = "2018.10.22"
end

--================================================================

function CameraCom_PanLeft()
	LogTrace("CameraCom_PanLeft")
	LogWarn("Pan Left not supported")
end


function CameraCom_PanRight()
	LogTrace("CameraCom_PanRight")
	LogWarn("Pan Right not supported")
end


function CameraCom_PanScan()
	LogTrace("CameraCom_PanScan")
	LogWarn("Pan Scan not Supported")
end


function CameraCom_TiltUp()
	LogTrace("CameraCom_TiltUp")
	LogWarn("Tilt Up not supported")
end


function CameraCom_TiltDown()
	LogTrace("CameraCom_TiltDown")
	LogWarn("Tilt Down not supported")
end


function CameraCom_TiltScan()
	LogTrace("CameraCom_TiltScan")
	LogWarn("Tilt Scan not Supported")
end


function CameraCom_ZoomIn()
	LogTrace("CameraCom_ZoomIn")
	LogWarn("Zoom In not supported")
end


function CameraCom_ZoomOut()
	LogTrace("CameraCom_ZoomOut")
	LogWarn("Zoom Out not supported")
end


function CameraCom_FocusNear()
	LogTrace("CameraCom_FocusNear")
	LogWarn("Focus Near not supported")
end


function CameraCom_FocusFar()
	LogTrace("CameraCom_FocusFar")
	LogWarn("Focus Far not supported")
end


function CameraCom_IrisOpen()
	LogTrace("CameraCom_IrisOpen")
	LogWarn("Iris Open not supported")
end


function CameraCom_IrisClose()
	LogTrace("CameraCom_IrisClose")
	LogWarn("Iris Close not supported")
end


function CameraCom_AutoFocus()
	LogTrace("CameraCom_AutoFocus")
	LogWarn("Auto Focus not supported")
end


function CameraCom_AutoIris()
	LogTrace("CameraCom_AutoIris")
	LogWarn("Auto Iris not supported")
end


function CameraCom_Home()
	LogTrace("CameraCom_Home")
	LogWarn("Home not supported")
end


function CameraCom_MoveTo(XPos, YPos, Width, Height)
	LogTrace("CameraCom_MoveTo  X:%d  Y:%d  W:%d H:%d", XPos, YPos, Width, Height)
	LogWarn("Move To not supported")
end


function CameraCom_NightMode(IsNight)
	LogTrace("CameraCom_NightMode  Night:%s", tostring(IsNight))
	
	-- local DayNightVal = (IsNight) and 1 or 0
	-- local url = BuildHTTPString(string.format("quality?cmd=set&DayNight=%d&camid=%d", DayNightVal, GetCameraID()))

	-- UrlGet(url)
	
	-- EX_CMD.ENABLE_IR ({Value = IsNight and 'Enable' or 'Disable'})
end


function CameraCom_Preset(PresetIndex)
	LogTrace("CameraCom_Preset  Index: %d", PresetIndex)
	LogWarn("Presets not supported")
end


function CameraCom_SetAddress(TargAddress)
	LogTrace("CameraCom_SetAddress")
	UrlSetAddress(TargAddress)
	Camera:QuerySettings()
end


function CameraCom_SetHttpPort(TargPort)
	LogTrace("CameraCom_SetHttpPort")
	UrlSetHttpPort(TargPort)
	Camera:QuerySettings()
end


function CameraCom_SetRtspPort(TargPort)
	LogTrace("CameraCom_SetRtspPort")
	UrlSetRtspPort(TargPort)
	Camera:QuerySettings()
end


function CameraCom_SetAuthenticationRequired(AuthRequired)
	LogTrace("CameraCom_SetAuthenticationRequired")
	UrlSetAuthenticationType(AuthType)
	Camera:QuerySettings()
end


function CameraCom_SetAuthenticationType(AuthType)
	LogTrace("CameraCom_SetAuthenticationType")
	UrlSetAuthenticationType(AuthType)
	Camera:QuerySettings()
end


function CameraCom_SetUsername(TargUserName)
	LogTrace("CameraCom_SetUsername")
	UrlSetUserName(TargUserName)
	Camera:QuerySettings()
end


function CameraCom_SetPassword(NewPassword)
	LogTrace("CameraCom_SetPassword")
	UrlSetPassword(NewPassword)
	Camera:QuerySettings()
end


function CameraCom_SetPubliclyAccessible(PublicAccess)
	LogTrace("CameraCom_SetPubliclyAccessible")
	-- not supported
	LogWarn("SET_PUBLICLY_ACCESSIBLE command is not supported")
end


ld_CameraCommunicator = true			-- for development

