--[[=============================================================================
    File is: camera_apis.lua

    Copyright 2018 Control4 Corporation. All Rights Reserved.
	
	API calls for developers using camera template code
===============================================================================]]

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.lock_status = "2018.03.20"
end

--==================================================================

function InitializeCamera()
	TheCamera:InitialSetup()
end

--==================================================================

function ReportPropertyDefaults()
	TheCamera:ReportPropertyDefaults()
end

--==================================================================

function GetCameraID()
	return TheCamera:GetID()
end

function SetCameraID(NewID)
	TheCamera:SetID(NewID)
end

----------

function GetPTZIncrement()
	return (TheCamera ~= nil) and TheCamera:GetPTZIncrement() or 1
end

function SetPTZIncrement(NewIncrement)
	if (TheCamera ~= nil) then 
		TheCamera:SetPTZIncrement(NewIncrement) 
	end
end

----------

function HasEPTZ()
	return TheCamera:HasEPTZ()
end

function SetEPTZFlag(FlagValue)
	TheCamera:SetEPTZ(FlagValue)
end

----------

function HasAutoFocus()
	return TheCamera:HasAutoFocus()
end

function SetAutoFocusFlag(FlagValue)
	TheCamera:SetAutoFocus(FlagValue)
end

----------

ld_camera_status = true			-- for development
