--[[=============================================================================
	File is: device_specific_unique.lua  (Pakedge Camera 2MP Static)
	
    Copyright 2019 Control4 Corporation. All Rights Reserved.
===============================================================================]]

DRIVER_NAME = "Pakedge 2MP Static Camera"

gThisIsAPTZDriver = false
gCanUpdateFirmware = false


--=========================================================================
--=========================================================================
-- Suppliment the pakedge_camera table

function Camera:GetImageSize(size_x, size_y)

	local DUMMY_HIGH_VALUE = 100000
	local UseIndex = 0
	local MinIndex = DUMMY_HIGH_VALUE
	local MinString = ""
	local UseString = ""
	
	for k, v in pairs(gJPEGTEXT) do
		if(v < MinIndex) then
			MinString = k
			MinIndex = v
		end
		
		if((v > UseIndex) and (v <= size_y)) then
			UseIndex = v
			UseString = k
		end
	end

	if(UseIndex == 0) then
		UseIndex = MinIndex
		UseString = MinString
	end

	return UseString

end


function Camera:PTZControl(control, value)
	return string.format("control?%s=%s&stop=1&camid=%d", control, value, GetCameraID())
end


--=========================================================================
--=========================================================================
-- Suppliment the FirmwareControl table

DEFAULT_FIRMWARE_BIN_FILE = "FillThisInWithSomethingReal.bin"
DEFAULT_FIRMWARE_BIN_PATH = "http://update2.control4.com/release/firmware/pakedge_camera/"

function FirmwareControl:UpdateModelFirmwareTarget()
	self._DefaultFirmwareImageURL = string.format("%s%s", DEFAULT_FIRMWARE_BIN_PATH, DEFAULT_FIRMWARE_BIN_FILE)
	self._FirmwareBinFile = DEFAULT_FIRMWARE_BIN_FILE
end


