--[[=============================================================================
	File is: url_device_specific.lua
	
    Copyright 2019 Control4 Corporation. All Rights Reserved.
===============================================================================]]

--[[=====================================================================
	Sample of a callback routine.
	
	A reference to the callback routines are sent as an optional parameter to
	UrlGet, UrlPut, and UrlPost.
	
	This routine will be called when the transfer completes
	
  The format of the functions is:
	function(ResponseCode, Data)
		ResponseCode is the status of the call e.g 200 means success, 401 means unauthorized
		Data is the information that was returned from the transfer callback

function Resp_XXX(ResponseCode, Data)
	LogTrace("Resp_XXX  ResponseCode is %d  Data is %s", tonumber(ResponseCode), tostring(Data))

	-- Handling code goes here
	
end

--]]


--[[========================================================================
  Sample of an old-style callback.  We are hoping to get rid of these
  
  These are added to the RESPONSES table.  References are put into the RESPONSES table
  and keyed by Ticket numbers

  The format of the functions is:
	function(data, responsecode)
		data is the information that was returned from the transfer callback
		responsecode is the status of the call e.g 200 means success, 401 means unauthorized


		
function RESPONSES.ResponseRoutine(data, responsecode)
	LogTrace("RESPONSES.ResponseRoutine: rc: %s  data %s", tostring(responsecode), data)

end

--]]

--------------------
