--[[=============================================================================
	File is: url_apis.lua
	Copyright 2019 Control4 Corporation. All Rights Reserved.
===============================================================================]]


-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.url_apis = "2019.04.16"
end

function InitializeUrlCommunication(UserName, Password, AuthRequired, AuthType, Address, HttpPort, RtspPort)
	TheUrlCom:InitialSetup(UserName, Password, AuthRequired, AuthType, Address, HttpPort, RtspPort)
end

--==================================================================

function SetNetworkBindingID(NewID)
	TheUrlCom:SetNetworkBindingID(NewID)
end


function GetNetworkBindingID()
	return TheUrlCom:GetNetworkBindingID()
end


function MarkNetworkOnline()
	C4:SetBindingStatus(GetNetworkBindingID(), "online")
end


function MarkNetworkOffline()
	C4:SetBindingStatus(GetNetworkBindingID(), "offline")
end


--==================================================================

function BuildHTTPString(InString)
	return TheUrlCom:BuildHTTP(InString)
end


function UrlPutRequest(url, xml)	-- Depricated
	LogInfo("UrlPutRequest has been depricated.  Consider using UrlPut")
	return TheUrlCom:PutRequest(url, xml)
end

function UrlPut(url, data, headers, Callback)
	return TheUrlCom:Put(url, data, headers, Callback)
end



function UrlGetRequest(url)		-- Depricated
	LogInfo("UrlGetRequest has been depricated.  Consider using UrlGet")
	return TheUrlCom:GetRequest(url)
end

function UrlGet(url, Callback)
	TheUrlCom:Get(url, Callback)
end


function UrlPostRequest(url, data, header)	-- Depricated
	LogInfo("UrlPostRequest has been depricated.  Consider using UrlPost")
	return TheUrlCom:PostRequest(url, data, header)
end

function UrlPost(url, data, header, Callback)
	return TheUrlCom:Post(url, data, header, Callback)
end

function UrlPostRaw(url, data, header, Callback)
	return TheUrlCom:PostRaw(url, data, header, Callback)
end


--==================================================================

function UrlSetResponse(TicketID, ResponseRoutine)
	gTickets[TicketID] = ResponseRoutine
end

--==================================================================

function UrlGetAddress()
	return TheUrlCom:GetAddress()
end

function UrlSetAddress(NewAddress)
	TheUrlCom:SetAddress(NewAddress)
end

function UrlGetHttpPort()
	return TheUrlCom:GetHttpPort()
end

function UrlSetHttpPort(NewPort)
	TheUrlCom:SetHttpPort(NewPort)
end

function UrlGetRtspPort()
	return TheUrlCom:GetRtspPort()
end

function UrlSetRtspPort(NewPort)
	TheUrlCom:SetRtspPort(NewPort)
end

function UrlIsAuthenticationRequired()
	return TheUrlCom:IsAuthenticationRequired()
end

function UrlSetAuthenticationRequired(IsRequired)
	TheUrlCom:SetAuthenticationRequired(IsRequired)
end

function UrlGetAuthenticationType()
	return TheUrlCom:GetAuthenticationType()
end

function UrlAuthIsBasic()
	return TheUrlCom:AuthIsBasic()
end

function UrlAuthIsDigest()
	return TheUrlCom:AuthIsDigest()
end

function UrlSetAuthenticationType(NewType)
	TheUrlCom:SetAuthenticationType(NewType)
end

function UrlGetUserName()
	return TheUrlCom:GetUserName()
end

function UrlSetUserName(NewName)
	TheUrlCom:SetUserName(NewName)
end

function UrlGetPassword()
	return TheUrlCom:GetPassword()
end

function UrlSetPassword(NewPassword)
	TheUrlCom:SetPassword(NewPassword)
end

function UrlAuthHeader()
	return TheUrlCom:AuthHeader()
end

ld_urlapis = true				-- for development
